/**
 * Test case for apEnvMixin.
 * Runs with mocha.
 */
'use strict'

const ApEnvMixin = require('../lib/ap_env_mixin.js').default
const React = require('react')
const ReactDOM = require('react-dom/server')
const assert = require('assert')

describe('ap-env-mixin', () => {
  before((done) => {
    done()
  })

  after((done) => {
    done()
  })

  it('Ap env mixin', (done) => {

    const MockClass = React.createClass({
      mixins: [
        ApEnvMixin
      ],
      render () {
        const s = this
        return React.createElement('div', {}, s.props.children)
      },
      componentWillMount () {
        const s = this
        assert.equal(s.getEnv(), 'production')
        assert.ok(s.isProductionEnv())
      }
    })

    let grandChild = React.createElement(MockClass, {})
    let child = React.createElement(MockClass, {}, grandChild)
    let parent = React.createElement(MockClass,
      {
        NODE_ENV: 'production'
      },
      child
    )

    let html = ReactDOM.renderToString(parent)
    assert.ok(html)
    console.log(html)
    done()
  })
})

/* global describe, before, after, it */
